#include "atmosphere_abilityHandler.h"
#include "atmosphere_triggerHandler.h"

#ifdef __cplusplus
	extern "C"{
#endif

void ATMO_AbilityHandler(unsigned int abilityHandleId, ATMO_Value_t *value) {
	switch(abilityHandleId) {
		case ATMO_ABILITY(AmbientLightCharacteristic, trigger):
		{
			ATMO_Value_t AmbientLightCharacteristic_Value;
			ATMO_InitValue(&AmbientLightCharacteristic_Value);
			AmbientLightCharacteristic_trigger(value, &AmbientLightCharacteristic_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(AmbientLightCharacteristic, triggered), &AmbientLightCharacteristic_Value);
			ATMO_FreeValue(&AmbientLightCharacteristic_Value);
			break;
		}
		case ATMO_ABILITY(AmbientLightCharacteristic, setup):
		{
			ATMO_Value_t AmbientLightCharacteristic_Value;
			ATMO_InitValue(&AmbientLightCharacteristic_Value);
			AmbientLightCharacteristic_setup(value, &AmbientLightCharacteristic_Value);
			ATMO_FreeValue(&AmbientLightCharacteristic_Value);
			break;
		}
		case ATMO_ABILITY(AmbientLightCharacteristic, setValue):
		{
			ATMO_Value_t AmbientLightCharacteristic_Value;
			ATMO_InitValue(&AmbientLightCharacteristic_Value);
			AmbientLightCharacteristic_setValue(value, &AmbientLightCharacteristic_Value);
			ATMO_FreeValue(&AmbientLightCharacteristic_Value);
			break;
		}
		case ATMO_ABILITY(AmbientLightCharacteristic, written):
		{
			ATMO_Value_t AmbientLightCharacteristic_Value;
			ATMO_InitValue(&AmbientLightCharacteristic_Value);
			AmbientLightCharacteristic_written(value, &AmbientLightCharacteristic_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(AmbientLightCharacteristic, written), &AmbientLightCharacteristic_Value);
			ATMO_FreeValue(&AmbientLightCharacteristic_Value);
			break;
		}
		case ATMO_ABILITY(AmbientLightCharacteristic, subscibed):
		{
			ATMO_Value_t AmbientLightCharacteristic_Value;
			ATMO_InitValue(&AmbientLightCharacteristic_Value);
			AmbientLightCharacteristic_subscibed(value, &AmbientLightCharacteristic_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(AmbientLightCharacteristic, subscibed), &AmbientLightCharacteristic_Value);
			ATMO_FreeValue(&AmbientLightCharacteristic_Value);
			break;
		}
		case ATMO_ABILITY(AmbientLightCharacteristic, unsubscribed):
		{
			ATMO_Value_t AmbientLightCharacteristic_Value;
			ATMO_InitValue(&AmbientLightCharacteristic_Value);
			AmbientLightCharacteristic_unsubscribed(value, &AmbientLightCharacteristic_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(AmbientLightCharacteristic, unsubscribed), &AmbientLightCharacteristic_Value);
			ATMO_FreeValue(&AmbientLightCharacteristic_Value);
			break;
		}
		case ATMO_ABILITY(SX9500Touch, trigger):
		{
			ATMO_Value_t SX9500Touch_Value;
			ATMO_InitValue(&SX9500Touch_Value);
			SX9500Touch_trigger(value, &SX9500Touch_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SX9500Touch, triggered), &SX9500Touch_Value);
			ATMO_FreeValue(&SX9500Touch_Value);
			break;
		}
		case ATMO_ABILITY(SX9500Touch, setup):
		{
			ATMO_Value_t SX9500Touch_Value;
			ATMO_InitValue(&SX9500Touch_Value);
			SX9500Touch_setup(value, &SX9500Touch_Value);
			ATMO_FreeValue(&SX9500Touch_Value);
			break;
		}
		case ATMO_ABILITY(SX9500Touch, getTouchData):
		{
			ATMO_Value_t SX9500Touch_Value;
			ATMO_InitValue(&SX9500Touch_Value);
			SX9500Touch_getTouchData(value, &SX9500Touch_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SX9500Touch, touchDataRead), &SX9500Touch_Value);
			ATMO_FreeValue(&SX9500Touch_Value);
			break;
		}
		case ATMO_ABILITY(SX9500Touch, pressUp):
		{
			ATMO_Value_t SX9500Touch_Value;
			ATMO_InitValue(&SX9500Touch_Value);
			SX9500Touch_pressUp(value, &SX9500Touch_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SX9500Touch, upPressed), &SX9500Touch_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SX9500Touch, touchDataRead), &SX9500Touch_Value);
			ATMO_FreeValue(&SX9500Touch_Value);
			break;
		}
		case ATMO_ABILITY(SX9500Touch, pressDown):
		{
			ATMO_Value_t SX9500Touch_Value;
			ATMO_InitValue(&SX9500Touch_Value);
			SX9500Touch_pressDown(value, &SX9500Touch_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SX9500Touch, downPressed), &SX9500Touch_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SX9500Touch, touchDataRead), &SX9500Touch_Value);
			ATMO_FreeValue(&SX9500Touch_Value);
			break;
		}
		case ATMO_ABILITY(SX9500Touch, pressLeft):
		{
			ATMO_Value_t SX9500Touch_Value;
			ATMO_InitValue(&SX9500Touch_Value);
			SX9500Touch_pressLeft(value, &SX9500Touch_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SX9500Touch, leftPressed), &SX9500Touch_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SX9500Touch, touchDataRead), &SX9500Touch_Value);
			ATMO_FreeValue(&SX9500Touch_Value);
			break;
		}
		case ATMO_ABILITY(SX9500Touch, pressRight):
		{
			ATMO_Value_t SX9500Touch_Value;
			ATMO_InitValue(&SX9500Touch_Value);
			SX9500Touch_pressRight(value, &SX9500Touch_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SX9500Touch, rightPressed), &SX9500Touch_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SX9500Touch, touchDataRead), &SX9500Touch_Value);
			ATMO_FreeValue(&SX9500Touch_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, trigger):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_trigger(value, &EmbeddedPageController_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedPageController, triggered), &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, setup):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_setup(value, &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, displayRootPage):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_displayRootPage(value, &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, navigateUp):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_navigateUp(value, &EmbeddedPageController_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedPageController, navigateUp), &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, navigateDown):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_navigateDown(value, &EmbeddedPageController_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedPageController, navigateDown), &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, navigateLeft):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_navigateLeft(value, &EmbeddedPageController_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedPageController, navigateLeft), &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, navigateRight):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_navigateRight(value, &EmbeddedPageController_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedPageController, navigateRight), &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, processTopRightButton):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_processTopRightButton(value, &EmbeddedPageController_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedPageController, processTopRightButton), &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, processBottomRightButton):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_processBottomRightButton(value, &EmbeddedPageController_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedPageController, processBottomRightButton), &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, processTopLeftButton):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_processTopLeftButton(value, &EmbeddedPageController_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedPageController, processTopLeftButton), &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, processBottomLeftButton):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_processBottomLeftButton(value, &EmbeddedPageController_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedPageController, processBottomLeftButton), &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(AmientLight_Pag, trigger):
		{
			ATMO_Value_t AmientLight_Pag_Value;
			ATMO_InitValue(&AmientLight_Pag_Value);
			AmientLight_Pag_trigger(value, &AmientLight_Pag_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(AmientLight_Pag, triggered), &AmientLight_Pag_Value);
			ATMO_FreeValue(&AmientLight_Pag_Value);
			break;
		}
		case ATMO_ABILITY(AmientLight_Pag, displayPage):
		{
			ATMO_Value_t AmientLight_Pag_Value;
			ATMO_InitValue(&AmientLight_Pag_Value);
			AmientLight_Pag_displayPage(value, &AmientLight_Pag_Value);
			ATMO_FreeValue(&AmientLight_Pag_Value);
			break;
		}
		case ATMO_ABILITY(AmientLight_Pag, onDisplayed):
		{
			ATMO_Value_t AmientLight_Pag_Value;
			ATMO_InitValue(&AmientLight_Pag_Value);
			AmientLight_Pag_onDisplayed(value, &AmientLight_Pag_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(AmientLight_Pag, onDisplayed), &AmientLight_Pag_Value);
			ATMO_FreeValue(&AmientLight_Pag_Value);
			break;
		}
		case ATMO_ABILITY(AmientLight_Pag, topRightButtonPressed):
		{
			ATMO_Value_t AmientLight_Pag_Value;
			ATMO_InitValue(&AmientLight_Pag_Value);
			AmientLight_Pag_topRightButtonPressed(value, &AmientLight_Pag_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(AmientLight_Pag, topRightButtonPressed), &AmientLight_Pag_Value);
			ATMO_FreeValue(&AmientLight_Pag_Value);
			break;
		}
		case ATMO_ABILITY(AmientLight_Pag, bottomRightButtonPressed):
		{
			ATMO_Value_t AmientLight_Pag_Value;
			ATMO_InitValue(&AmientLight_Pag_Value);
			AmientLight_Pag_bottomRightButtonPressed(value, &AmientLight_Pag_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(AmientLight_Pag, bottomRightButtonPressed), &AmientLight_Pag_Value);
			ATMO_FreeValue(&AmientLight_Pag_Value);
			break;
		}
		case ATMO_ABILITY(AmientLight_Pag, topLeftButtonPressed):
		{
			ATMO_Value_t AmientLight_Pag_Value;
			ATMO_InitValue(&AmientLight_Pag_Value);
			AmientLight_Pag_topLeftButtonPressed(value, &AmientLight_Pag_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(AmientLight_Pag, topLeftButtonPressed), &AmientLight_Pag_Value);
			ATMO_FreeValue(&AmientLight_Pag_Value);
			break;
		}
		case ATMO_ABILITY(AmientLight_Pag, bottomLeftButtonPressed):
		{
			ATMO_Value_t AmientLight_Pag_Value;
			ATMO_InitValue(&AmientLight_Pag_Value);
			AmientLight_Pag_bottomLeftButtonPressed(value, &AmientLight_Pag_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(AmientLight_Pag, bottomLeftButtonPressed), &AmientLight_Pag_Value);
			ATMO_FreeValue(&AmientLight_Pag_Value);
			break;
		}
		case ATMO_ABILITY(AmientLight_Pag, setup):
		{
			ATMO_Value_t AmientLight_Pag_Value;
			ATMO_InitValue(&AmientLight_Pag_Value);
			AmientLight_Pag_setup(value, &AmientLight_Pag_Value);
			ATMO_FreeValue(&AmientLight_Pag_Value);
			break;
		}
		case ATMO_ABILITY(AmientLight_Pag, onLeave):
		{
			ATMO_Value_t AmientLight_Pag_Value;
			ATMO_InitValue(&AmientLight_Pag_Value);
			AmientLight_Pag_onLeave(value, &AmientLight_Pag_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(AmientLight_Pag, onLeave), &AmientLight_Pag_Value);
			ATMO_FreeValue(&AmientLight_Pag_Value);
			break;
		}
		case ATMO_ABILITY(AmientLight_Pag, setLabel):
		{
			ATMO_Value_t AmientLight_Pag_Value;
			ATMO_InitValue(&AmientLight_Pag_Value);
			AmientLight_Pag_setLabel(value, &AmientLight_Pag_Value);
			ATMO_FreeValue(&AmientLight_Pag_Value);
			break;
		}
		case ATMO_ABILITY(Interval, trigger):
		{
			ATMO_Value_t Interval_Value;
			ATMO_InitValue(&Interval_Value);
			Interval_trigger(value, &Interval_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Interval, triggered), &Interval_Value);
			ATMO_FreeValue(&Interval_Value);
			break;
		}
		case ATMO_ABILITY(Interval, setup):
		{
			ATMO_Value_t Interval_Value;
			ATMO_InitValue(&Interval_Value);
			Interval_setup(value, &Interval_Value);
			ATMO_FreeValue(&Interval_Value);
			break;
		}
		case ATMO_ABILITY(Interval, interval):
		{
			ATMO_Value_t Interval_Value;
			ATMO_InitValue(&Interval_Value);
			Interval_interval(value, &Interval_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Interval, interval), &Interval_Value);
			ATMO_FreeValue(&Interval_Value);
			break;
		}
		case ATMO_ABILITY(TSL2572AmbientLight, trigger):
		{
			ATMO_Value_t TSL2572AmbientLight_Value;
			ATMO_InitValue(&TSL2572AmbientLight_Value);
			TSL2572AmbientLight_trigger(value, &TSL2572AmbientLight_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(TSL2572AmbientLight, triggered), &TSL2572AmbientLight_Value);
			ATMO_FreeValue(&TSL2572AmbientLight_Value);
			break;
		}
		case ATMO_ABILITY(TSL2572AmbientLight, setup):
		{
			ATMO_Value_t TSL2572AmbientLight_Value;
			ATMO_InitValue(&TSL2572AmbientLight_Value);
			TSL2572AmbientLight_setup(value, &TSL2572AmbientLight_Value);
			ATMO_FreeValue(&TSL2572AmbientLight_Value);
			break;
		}
		case ATMO_ABILITY(TSL2572AmbientLight, setEnabled):
		{
			ATMO_Value_t TSL2572AmbientLight_Value;
			ATMO_InitValue(&TSL2572AmbientLight_Value);
			TSL2572AmbientLight_setEnabled(value, &TSL2572AmbientLight_Value);
			ATMO_FreeValue(&TSL2572AmbientLight_Value);
			break;
		}
		case ATMO_ABILITY(TSL2572AmbientLight, setDisabled):
		{
			ATMO_Value_t TSL2572AmbientLight_Value;
			ATMO_InitValue(&TSL2572AmbientLight_Value);
			TSL2572AmbientLight_setDisabled(value, &TSL2572AmbientLight_Value);
			ATMO_FreeValue(&TSL2572AmbientLight_Value);
			break;
		}
		case ATMO_ABILITY(TSL2572AmbientLight, setEnabledDisabled):
		{
			ATMO_Value_t TSL2572AmbientLight_Value;
			ATMO_InitValue(&TSL2572AmbientLight_Value);
			TSL2572AmbientLight_setEnabledDisabled(value, &TSL2572AmbientLight_Value);
			ATMO_FreeValue(&TSL2572AmbientLight_Value);
			break;
		}
		case ATMO_ABILITY(TSL2572AmbientLight, readAmbientLight):
		{
			ATMO_Value_t TSL2572AmbientLight_Value;
			ATMO_InitValue(&TSL2572AmbientLight_Value);
			TSL2572AmbientLight_readAmbientLight(value, &TSL2572AmbientLight_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(TSL2572AmbientLight, ambientLightRead), &TSL2572AmbientLight_Value);
			ATMO_FreeValue(&TSL2572AmbientLight_Value);
			break;
		}
		case ATMO_ABILITY(GetLightStr, trigger):
		{
			ATMO_Value_t GetLightStr_Value;
			ATMO_InitValue(&GetLightStr_Value);
			GetLightStr_trigger(value, &GetLightStr_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(GetLightStr, triggered), &GetLightStr_Value);
			ATMO_FreeValue(&GetLightStr_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedNxpRpkBacklight, trigger):
		{
			ATMO_Value_t EmbeddedNxpRpkBacklight_Value;
			ATMO_InitValue(&EmbeddedNxpRpkBacklight_Value);
			EmbeddedNxpRpkBacklight_trigger(value, &EmbeddedNxpRpkBacklight_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedNxpRpkBacklight, triggered), &EmbeddedNxpRpkBacklight_Value);
			ATMO_FreeValue(&EmbeddedNxpRpkBacklight_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedNxpRpkBacklight, setup):
		{
			ATMO_Value_t EmbeddedNxpRpkBacklight_Value;
			ATMO_InitValue(&EmbeddedNxpRpkBacklight_Value);
			EmbeddedNxpRpkBacklight_setup(value, &EmbeddedNxpRpkBacklight_Value);
			ATMO_FreeValue(&EmbeddedNxpRpkBacklight_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedNxpRpkBacklight, setBacklightOff):
		{
			ATMO_Value_t EmbeddedNxpRpkBacklight_Value;
			ATMO_InitValue(&EmbeddedNxpRpkBacklight_Value);
			EmbeddedNxpRpkBacklight_setBacklightOff(value, &EmbeddedNxpRpkBacklight_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedNxpRpkBacklight, backlightSet), &EmbeddedNxpRpkBacklight_Value);
			ATMO_FreeValue(&EmbeddedNxpRpkBacklight_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedNxpRpkBacklight, setBacklightLow):
		{
			ATMO_Value_t EmbeddedNxpRpkBacklight_Value;
			ATMO_InitValue(&EmbeddedNxpRpkBacklight_Value);
			EmbeddedNxpRpkBacklight_setBacklightLow(value, &EmbeddedNxpRpkBacklight_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedNxpRpkBacklight, backlightSet), &EmbeddedNxpRpkBacklight_Value);
			ATMO_FreeValue(&EmbeddedNxpRpkBacklight_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedNxpRpkBacklight, setBacklightMedium):
		{
			ATMO_Value_t EmbeddedNxpRpkBacklight_Value;
			ATMO_InitValue(&EmbeddedNxpRpkBacklight_Value);
			EmbeddedNxpRpkBacklight_setBacklightMedium(value, &EmbeddedNxpRpkBacklight_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedNxpRpkBacklight, backlightSet), &EmbeddedNxpRpkBacklight_Value);
			ATMO_FreeValue(&EmbeddedNxpRpkBacklight_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedNxpRpkBacklight, setBacklightHigh):
		{
			ATMO_Value_t EmbeddedNxpRpkBacklight_Value;
			ATMO_InitValue(&EmbeddedNxpRpkBacklight_Value);
			EmbeddedNxpRpkBacklight_setBacklightHigh(value, &EmbeddedNxpRpkBacklight_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedNxpRpkBacklight, backlightSet), &EmbeddedNxpRpkBacklight_Value);
			ATMO_FreeValue(&EmbeddedNxpRpkBacklight_Value);
			break;
		}
		case ATMO_ABILITY(TapCountPage, trigger):
		{
			ATMO_Value_t TapCountPage_Value;
			ATMO_InitValue(&TapCountPage_Value);
			TapCountPage_trigger(value, &TapCountPage_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(TapCountPage, triggered), &TapCountPage_Value);
			ATMO_FreeValue(&TapCountPage_Value);
			break;
		}
		case ATMO_ABILITY(TapCountPage, displayPage):
		{
			ATMO_Value_t TapCountPage_Value;
			ATMO_InitValue(&TapCountPage_Value);
			TapCountPage_displayPage(value, &TapCountPage_Value);
			ATMO_FreeValue(&TapCountPage_Value);
			break;
		}
		case ATMO_ABILITY(TapCountPage, onDisplayed):
		{
			ATMO_Value_t TapCountPage_Value;
			ATMO_InitValue(&TapCountPage_Value);
			TapCountPage_onDisplayed(value, &TapCountPage_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(TapCountPage, onDisplayed), &TapCountPage_Value);
			ATMO_FreeValue(&TapCountPage_Value);
			break;
		}
		case ATMO_ABILITY(TapCountPage, topRightButtonPressed):
		{
			ATMO_Value_t TapCountPage_Value;
			ATMO_InitValue(&TapCountPage_Value);
			TapCountPage_topRightButtonPressed(value, &TapCountPage_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(TapCountPage, topRightButtonPressed), &TapCountPage_Value);
			ATMO_FreeValue(&TapCountPage_Value);
			break;
		}
		case ATMO_ABILITY(TapCountPage, bottomRightButtonPressed):
		{
			ATMO_Value_t TapCountPage_Value;
			ATMO_InitValue(&TapCountPage_Value);
			TapCountPage_bottomRightButtonPressed(value, &TapCountPage_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(TapCountPage, bottomRightButtonPressed), &TapCountPage_Value);
			ATMO_FreeValue(&TapCountPage_Value);
			break;
		}
		case ATMO_ABILITY(TapCountPage, topLeftButtonPressed):
		{
			ATMO_Value_t TapCountPage_Value;
			ATMO_InitValue(&TapCountPage_Value);
			TapCountPage_topLeftButtonPressed(value, &TapCountPage_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(TapCountPage, topLeftButtonPressed), &TapCountPage_Value);
			ATMO_FreeValue(&TapCountPage_Value);
			break;
		}
		case ATMO_ABILITY(TapCountPage, bottomLeftButtonPressed):
		{
			ATMO_Value_t TapCountPage_Value;
			ATMO_InitValue(&TapCountPage_Value);
			TapCountPage_bottomLeftButtonPressed(value, &TapCountPage_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(TapCountPage, bottomLeftButtonPressed), &TapCountPage_Value);
			ATMO_FreeValue(&TapCountPage_Value);
			break;
		}
		case ATMO_ABILITY(TapCountPage, setup):
		{
			ATMO_Value_t TapCountPage_Value;
			ATMO_InitValue(&TapCountPage_Value);
			TapCountPage_setup(value, &TapCountPage_Value);
			ATMO_FreeValue(&TapCountPage_Value);
			break;
		}
		case ATMO_ABILITY(TapCountPage, onLeave):
		{
			ATMO_Value_t TapCountPage_Value;
			ATMO_InitValue(&TapCountPage_Value);
			TapCountPage_onLeave(value, &TapCountPage_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(TapCountPage, onLeave), &TapCountPage_Value);
			ATMO_FreeValue(&TapCountPage_Value);
			break;
		}
		case ATMO_ABILITY(TapCountPage, setLabel):
		{
			ATMO_Value_t TapCountPage_Value;
			ATMO_InitValue(&TapCountPage_Value);
			TapCountPage_setLabel(value, &TapCountPage_Value);
			ATMO_FreeValue(&TapCountPage_Value);
			break;
		}
		case ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, trigger):
		{
			ATMO_Value_t FXOS8700AccelerometerMagnetometer_Value;
			ATMO_InitValue(&FXOS8700AccelerometerMagnetometer_Value);
			FXOS8700AccelerometerMagnetometer_trigger(value, &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, triggered), &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_FreeValue(&FXOS8700AccelerometerMagnetometer_Value);
			break;
		}
		case ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, setup):
		{
			ATMO_Value_t FXOS8700AccelerometerMagnetometer_Value;
			ATMO_InitValue(&FXOS8700AccelerometerMagnetometer_Value);
			FXOS8700AccelerometerMagnetometer_setup(value, &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_FreeValue(&FXOS8700AccelerometerMagnetometer_Value);
			break;
		}
		case ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, setEnabled):
		{
			ATMO_Value_t FXOS8700AccelerometerMagnetometer_Value;
			ATMO_InitValue(&FXOS8700AccelerometerMagnetometer_Value);
			FXOS8700AccelerometerMagnetometer_setEnabled(value, &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_FreeValue(&FXOS8700AccelerometerMagnetometer_Value);
			break;
		}
		case ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, setDisabled):
		{
			ATMO_Value_t FXOS8700AccelerometerMagnetometer_Value;
			ATMO_InitValue(&FXOS8700AccelerometerMagnetometer_Value);
			FXOS8700AccelerometerMagnetometer_setDisabled(value, &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_FreeValue(&FXOS8700AccelerometerMagnetometer_Value);
			break;
		}
		case ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, setEnabledDisabled):
		{
			ATMO_Value_t FXOS8700AccelerometerMagnetometer_Value;
			ATMO_InitValue(&FXOS8700AccelerometerMagnetometer_Value);
			FXOS8700AccelerometerMagnetometer_setEnabledDisabled(value, &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_FreeValue(&FXOS8700AccelerometerMagnetometer_Value);
			break;
		}
		case ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, getAccelData):
		{
			ATMO_Value_t FXOS8700AccelerometerMagnetometer_Value;
			ATMO_InitValue(&FXOS8700AccelerometerMagnetometer_Value);
			FXOS8700AccelerometerMagnetometer_getAccelData(value, &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, accelDataRead), &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_FreeValue(&FXOS8700AccelerometerMagnetometer_Value);
			break;
		}
		case ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, getAccelX):
		{
			ATMO_Value_t FXOS8700AccelerometerMagnetometer_Value;
			ATMO_InitValue(&FXOS8700AccelerometerMagnetometer_Value);
			FXOS8700AccelerometerMagnetometer_getAccelX(value, &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, accelXRead), &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_FreeValue(&FXOS8700AccelerometerMagnetometer_Value);
			break;
		}
		case ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, getAccelY):
		{
			ATMO_Value_t FXOS8700AccelerometerMagnetometer_Value;
			ATMO_InitValue(&FXOS8700AccelerometerMagnetometer_Value);
			FXOS8700AccelerometerMagnetometer_getAccelY(value, &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, accelYRead), &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_FreeValue(&FXOS8700AccelerometerMagnetometer_Value);
			break;
		}
		case ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, getAccelZ):
		{
			ATMO_Value_t FXOS8700AccelerometerMagnetometer_Value;
			ATMO_InitValue(&FXOS8700AccelerometerMagnetometer_Value);
			FXOS8700AccelerometerMagnetometer_getAccelZ(value, &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, accelZRead), &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_FreeValue(&FXOS8700AccelerometerMagnetometer_Value);
			break;
		}
		case ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, getMagData):
		{
			ATMO_Value_t FXOS8700AccelerometerMagnetometer_Value;
			ATMO_InitValue(&FXOS8700AccelerometerMagnetometer_Value);
			FXOS8700AccelerometerMagnetometer_getMagData(value, &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, magDataRead), &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_FreeValue(&FXOS8700AccelerometerMagnetometer_Value);
			break;
		}
		case ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, getMagX):
		{
			ATMO_Value_t FXOS8700AccelerometerMagnetometer_Value;
			ATMO_InitValue(&FXOS8700AccelerometerMagnetometer_Value);
			FXOS8700AccelerometerMagnetometer_getMagX(value, &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, magXRead), &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_FreeValue(&FXOS8700AccelerometerMagnetometer_Value);
			break;
		}
		case ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, getMagY):
		{
			ATMO_Value_t FXOS8700AccelerometerMagnetometer_Value;
			ATMO_InitValue(&FXOS8700AccelerometerMagnetometer_Value);
			FXOS8700AccelerometerMagnetometer_getMagY(value, &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, magYRead), &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_FreeValue(&FXOS8700AccelerometerMagnetometer_Value);
			break;
		}
		case ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, getMagZ):
		{
			ATMO_Value_t FXOS8700AccelerometerMagnetometer_Value;
			ATMO_InitValue(&FXOS8700AccelerometerMagnetometer_Value);
			FXOS8700AccelerometerMagnetometer_getMagZ(value, &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, magZRead), &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_FreeValue(&FXOS8700AccelerometerMagnetometer_Value);
			break;
		}
		case ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, detectTap):
		{
			ATMO_Value_t FXOS8700AccelerometerMagnetometer_Value;
			ATMO_InitValue(&FXOS8700AccelerometerMagnetometer_Value);
			FXOS8700AccelerometerMagnetometer_detectTap(value, &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, tapDetected), &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_FreeValue(&FXOS8700AccelerometerMagnetometer_Value);
			break;
		}
		case ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, detectMotion):
		{
			ATMO_Value_t FXOS8700AccelerometerMagnetometer_Value;
			ATMO_InitValue(&FXOS8700AccelerometerMagnetometer_Value);
			FXOS8700AccelerometerMagnetometer_detectMotion(value, &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, motionDetected), &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_FreeValue(&FXOS8700AccelerometerMagnetometer_Value);
			break;
		}
		case ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, detectFreefall):
		{
			ATMO_Value_t FXOS8700AccelerometerMagnetometer_Value;
			ATMO_InitValue(&FXOS8700AccelerometerMagnetometer_Value);
			FXOS8700AccelerometerMagnetometer_detectFreefall(value, &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, freefallDetected), &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_FreeValue(&FXOS8700AccelerometerMagnetometer_Value);
			break;
		}
		case ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, enableFreefallDetection):
		{
			ATMO_Value_t FXOS8700AccelerometerMagnetometer_Value;
			ATMO_InitValue(&FXOS8700AccelerometerMagnetometer_Value);
			FXOS8700AccelerometerMagnetometer_enableFreefallDetection(value, &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_FreeValue(&FXOS8700AccelerometerMagnetometer_Value);
			break;
		}
		case ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, enableMotionDetection):
		{
			ATMO_Value_t FXOS8700AccelerometerMagnetometer_Value;
			ATMO_InitValue(&FXOS8700AccelerometerMagnetometer_Value);
			FXOS8700AccelerometerMagnetometer_enableMotionDetection(value, &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_FreeValue(&FXOS8700AccelerometerMagnetometer_Value);
			break;
		}
		case ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, enableTapDetection):
		{
			ATMO_Value_t FXOS8700AccelerometerMagnetometer_Value;
			ATMO_InitValue(&FXOS8700AccelerometerMagnetometer_Value);
			FXOS8700AccelerometerMagnetometer_enableTapDetection(value, &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_FreeValue(&FXOS8700AccelerometerMagnetometer_Value);
			break;
		}
		case ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, disableDetection):
		{
			ATMO_Value_t FXOS8700AccelerometerMagnetometer_Value;
			ATMO_InitValue(&FXOS8700AccelerometerMagnetometer_Value);
			FXOS8700AccelerometerMagnetometer_disableDetection(value, &FXOS8700AccelerometerMagnetometer_Value);
			ATMO_FreeValue(&FXOS8700AccelerometerMagnetometer_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedNxpRpkUserButtons, trigger):
		{
			ATMO_Value_t EmbeddedNxpRpkUserButtons_Value;
			ATMO_InitValue(&EmbeddedNxpRpkUserButtons_Value);
			EmbeddedNxpRpkUserButtons_trigger(value, &EmbeddedNxpRpkUserButtons_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedNxpRpkUserButtons, triggered), &EmbeddedNxpRpkUserButtons_Value);
			ATMO_FreeValue(&EmbeddedNxpRpkUserButtons_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedNxpRpkUserButtons, setup):
		{
			ATMO_Value_t EmbeddedNxpRpkUserButtons_Value;
			ATMO_InitValue(&EmbeddedNxpRpkUserButtons_Value);
			EmbeddedNxpRpkUserButtons_setup(value, &EmbeddedNxpRpkUserButtons_Value);
			ATMO_FreeValue(&EmbeddedNxpRpkUserButtons_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedNxpRpkUserButtons, topRightPushed):
		{
			ATMO_Value_t EmbeddedNxpRpkUserButtons_Value;
			ATMO_InitValue(&EmbeddedNxpRpkUserButtons_Value);
			EmbeddedNxpRpkUserButtons_topRightPushed(value, &EmbeddedNxpRpkUserButtons_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedNxpRpkUserButtons, topRightPushed), &EmbeddedNxpRpkUserButtons_Value);
			ATMO_FreeValue(&EmbeddedNxpRpkUserButtons_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedNxpRpkUserButtons, bottomRightPushed):
		{
			ATMO_Value_t EmbeddedNxpRpkUserButtons_Value;
			ATMO_InitValue(&EmbeddedNxpRpkUserButtons_Value);
			EmbeddedNxpRpkUserButtons_bottomRightPushed(value, &EmbeddedNxpRpkUserButtons_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedNxpRpkUserButtons, bottomRightPushed), &EmbeddedNxpRpkUserButtons_Value);
			ATMO_FreeValue(&EmbeddedNxpRpkUserButtons_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedNxpRpkUserButtons, topLeftPushed):
		{
			ATMO_Value_t EmbeddedNxpRpkUserButtons_Value;
			ATMO_InitValue(&EmbeddedNxpRpkUserButtons_Value);
			EmbeddedNxpRpkUserButtons_topLeftPushed(value, &EmbeddedNxpRpkUserButtons_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedNxpRpkUserButtons, topLeftPushed), &EmbeddedNxpRpkUserButtons_Value);
			ATMO_FreeValue(&EmbeddedNxpRpkUserButtons_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedNxpRpkUserButtons, bottomLeftPushed):
		{
			ATMO_Value_t EmbeddedNxpRpkUserButtons_Value;
			ATMO_InitValue(&EmbeddedNxpRpkUserButtons_Value);
			EmbeddedNxpRpkUserButtons_bottomLeftPushed(value, &EmbeddedNxpRpkUserButtons_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedNxpRpkUserButtons, bottomLeftPushed), &EmbeddedNxpRpkUserButtons_Value);
			ATMO_FreeValue(&EmbeddedNxpRpkUserButtons_Value);
			break;
		}
		case ATMO_ABILITY(ClearTapCount, trigger):
		{
			ATMO_Value_t ClearTapCount_Value;
			ATMO_InitValue(&ClearTapCount_Value);
			ClearTapCount_trigger(value, &ClearTapCount_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(ClearTapCount, triggered), &ClearTapCount_Value);
			ATMO_FreeValue(&ClearTapCount_Value);
			break;
		}
		case ATMO_ABILITY(x, trigger):
		{
			ATMO_Value_t x_Value;
			ATMO_InitValue(&x_Value);
			x_trigger(value, &x_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(x, triggered), &x_Value);
			ATMO_FreeValue(&x_Value);
			break;
		}
		case ATMO_ABILITY(x, setup):
		{
			ATMO_Value_t x_Value;
			ATMO_InitValue(&x_Value);
			x_setup(value, &x_Value);
			ATMO_FreeValue(&x_Value);
			break;
		}
		case ATMO_ABILITY(x, setValue):
		{
			ATMO_Value_t x_Value;
			ATMO_InitValue(&x_Value);
			x_setValue(value, &x_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(x, valueSet), &x_Value);
			ATMO_FreeValue(&x_Value);
			break;
		}
		case ATMO_ABILITY(x, getValue):
		{
			ATMO_Value_t x_Value;
			ATMO_InitValue(&x_Value);
			x_getValue(value, &x_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(x, valueRetrieved), &x_Value);
			ATMO_FreeValue(&x_Value);
			break;
		}
		case ATMO_ABILITY(Increment, trigger):
		{
			ATMO_Value_t Increment_Value;
			ATMO_InitValue(&Increment_Value);
			Increment_trigger(value, &Increment_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Increment, triggered), &Increment_Value);
			ATMO_FreeValue(&Increment_Value);
			break;
		}
		case ATMO_ABILITY(Increment, setup):
		{
			ATMO_Value_t Increment_Value;
			ATMO_InitValue(&Increment_Value);
			Increment_setup(value, &Increment_Value);
			ATMO_FreeValue(&Increment_Value);
			break;
		}
		case ATMO_ABILITY(Increment, performOperation):
		{
			ATMO_Value_t Increment_Value;
			ATMO_InitValue(&Increment_Value);
			Increment_performOperation(value, &Increment_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Increment, operationPerformed), &Increment_Value);
			ATMO_FreeValue(&Increment_Value);
			break;
		}
		case ATMO_ABILITY(TapCountChar, trigger):
		{
			ATMO_Value_t TapCountChar_Value;
			ATMO_InitValue(&TapCountChar_Value);
			TapCountChar_trigger(value, &TapCountChar_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(TapCountChar, triggered), &TapCountChar_Value);
			ATMO_FreeValue(&TapCountChar_Value);
			break;
		}
		case ATMO_ABILITY(TapCountChar, setup):
		{
			ATMO_Value_t TapCountChar_Value;
			ATMO_InitValue(&TapCountChar_Value);
			TapCountChar_setup(value, &TapCountChar_Value);
			ATMO_FreeValue(&TapCountChar_Value);
			break;
		}
		case ATMO_ABILITY(TapCountChar, setValue):
		{
			ATMO_Value_t TapCountChar_Value;
			ATMO_InitValue(&TapCountChar_Value);
			TapCountChar_setValue(value, &TapCountChar_Value);
			ATMO_FreeValue(&TapCountChar_Value);
			break;
		}
		case ATMO_ABILITY(TapCountChar, written):
		{
			ATMO_Value_t TapCountChar_Value;
			ATMO_InitValue(&TapCountChar_Value);
			TapCountChar_written(value, &TapCountChar_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(TapCountChar, written), &TapCountChar_Value);
			ATMO_FreeValue(&TapCountChar_Value);
			break;
		}
		case ATMO_ABILITY(TapCountChar, subscibed):
		{
			ATMO_Value_t TapCountChar_Value;
			ATMO_InitValue(&TapCountChar_Value);
			TapCountChar_subscibed(value, &TapCountChar_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(TapCountChar, subscibed), &TapCountChar_Value);
			ATMO_FreeValue(&TapCountChar_Value);
			break;
		}
		case ATMO_ABILITY(TapCountChar, unsubscribed):
		{
			ATMO_Value_t TapCountChar_Value;
			ATMO_InitValue(&TapCountChar_Value);
			TapCountChar_unsubscribed(value, &TapCountChar_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(TapCountChar, unsubscribed), &TapCountChar_Value);
			ATMO_FreeValue(&TapCountChar_Value);
			break;
		}
	}

}

#ifdef __cplusplus
}
#endif
