
#ifndef ATMO_ABILITY_HANDLER_H
#define ATMO_ABILITY_HANDLER_H

#include "atmosphere_platform.h"
#include "atmosphere_callbacks.h"

#include "../atmo/core.h"

#ifdef __cplusplus
	extern "C"{
#endif

#define ATMO_ABILITY(ELEMENT, NAME) ATMO_ ## ELEMENT ## _ABILITY_  ## NAME

void ATMO_AbilityHandler(unsigned int abilityHandleId, ATMO_Value_t *value);

#define ATMO_AmbientLightCharacteristic_ABILITY_trigger 0x1
#define ATMO_AmbientLightCharacteristic_ABILITY_setup 0x2
#define ATMO_AmbientLightCharacteristic_ABILITY_setValue 0x3
#define ATMO_AmbientLightCharacteristic_ABILITY_written 0x4
#define ATMO_AmbientLightCharacteristic_ABILITY_subscibed 0x5
#define ATMO_AmbientLightCharacteristic_ABILITY_unsubscribed 0x6
#define ATMO_SX9500Touch_ABILITY_trigger 0x7
#define ATMO_SX9500Touch_ABILITY_setup 0x8
#define ATMO_SX9500Touch_ABILITY_getTouchData 0x9
#define ATMO_SX9500Touch_ABILITY_pressUp 0xa
#define ATMO_SX9500Touch_ABILITY_pressDown 0xb
#define ATMO_SX9500Touch_ABILITY_pressLeft 0xc
#define ATMO_SX9500Touch_ABILITY_pressRight 0xd
#define ATMO_EmbeddedPageController_ABILITY_trigger 0xe
#define ATMO_EmbeddedPageController_ABILITY_setup 0xf
#define ATMO_EmbeddedPageController_ABILITY_displayRootPage 0x10
#define ATMO_EmbeddedPageController_ABILITY_navigateUp 0x11
#define ATMO_EmbeddedPageController_ABILITY_navigateDown 0x12
#define ATMO_EmbeddedPageController_ABILITY_navigateLeft 0x13
#define ATMO_EmbeddedPageController_ABILITY_navigateRight 0x14
#define ATMO_EmbeddedPageController_ABILITY_processTopRightButton 0x15
#define ATMO_EmbeddedPageController_ABILITY_processBottomRightButton 0x16
#define ATMO_EmbeddedPageController_ABILITY_processTopLeftButton 0x17
#define ATMO_EmbeddedPageController_ABILITY_processBottomLeftButton 0x18
#define ATMO_AmientLight_Pag_ABILITY_trigger 0x19
#define ATMO_AmientLight_Pag_ABILITY_displayPage 0x1a
#define ATMO_AmientLight_Pag_ABILITY_onDisplayed 0x1b
#define ATMO_AmientLight_Pag_ABILITY_topRightButtonPressed 0x1c
#define ATMO_AmientLight_Pag_ABILITY_bottomRightButtonPressed 0x1d
#define ATMO_AmientLight_Pag_ABILITY_topLeftButtonPressed 0x1e
#define ATMO_AmientLight_Pag_ABILITY_bottomLeftButtonPressed 0x1f
#define ATMO_AmientLight_Pag_ABILITY_setup 0x20
#define ATMO_AmientLight_Pag_ABILITY_onLeave 0x21
#define ATMO_AmientLight_Pag_ABILITY_setLabel 0x22
#define ATMO_Interval_ABILITY_trigger 0x23
#define ATMO_Interval_ABILITY_setup 0x24
#define ATMO_Interval_ABILITY_interval 0x25
#define ATMO_TSL2572AmbientLight_ABILITY_trigger 0x26
#define ATMO_TSL2572AmbientLight_ABILITY_setup 0x27
#define ATMO_TSL2572AmbientLight_ABILITY_setEnabled 0x28
#define ATMO_TSL2572AmbientLight_ABILITY_setDisabled 0x29
#define ATMO_TSL2572AmbientLight_ABILITY_setEnabledDisabled 0x2a
#define ATMO_TSL2572AmbientLight_ABILITY_readAmbientLight 0x2b
#define ATMO_GetLightStr_ABILITY_trigger 0x2c
#define ATMO_EmbeddedNxpRpkBacklight_ABILITY_trigger 0x2d
#define ATMO_EmbeddedNxpRpkBacklight_ABILITY_setup 0x2e
#define ATMO_EmbeddedNxpRpkBacklight_ABILITY_setBacklightOff 0x2f
#define ATMO_EmbeddedNxpRpkBacklight_ABILITY_setBacklightLow 0x30
#define ATMO_EmbeddedNxpRpkBacklight_ABILITY_setBacklightMedium 0x31
#define ATMO_EmbeddedNxpRpkBacklight_ABILITY_setBacklightHigh 0x32
#define ATMO_TapCountPage_ABILITY_trigger 0x33
#define ATMO_TapCountPage_ABILITY_displayPage 0x34
#define ATMO_TapCountPage_ABILITY_onDisplayed 0x35
#define ATMO_TapCountPage_ABILITY_topRightButtonPressed 0x36
#define ATMO_TapCountPage_ABILITY_bottomRightButtonPressed 0x37
#define ATMO_TapCountPage_ABILITY_topLeftButtonPressed 0x38
#define ATMO_TapCountPage_ABILITY_bottomLeftButtonPressed 0x39
#define ATMO_TapCountPage_ABILITY_setup 0x3a
#define ATMO_TapCountPage_ABILITY_onLeave 0x3b
#define ATMO_TapCountPage_ABILITY_setLabel 0x3c
#define ATMO_FXOS8700AccelerometerMagnetometer_ABILITY_trigger 0x3d
#define ATMO_FXOS8700AccelerometerMagnetometer_ABILITY_setup 0x3e
#define ATMO_FXOS8700AccelerometerMagnetometer_ABILITY_setEnabled 0x3f
#define ATMO_FXOS8700AccelerometerMagnetometer_ABILITY_setDisabled 0x40
#define ATMO_FXOS8700AccelerometerMagnetometer_ABILITY_setEnabledDisabled 0x41
#define ATMO_FXOS8700AccelerometerMagnetometer_ABILITY_getAccelData 0x42
#define ATMO_FXOS8700AccelerometerMagnetometer_ABILITY_getAccelX 0x43
#define ATMO_FXOS8700AccelerometerMagnetometer_ABILITY_getAccelY 0x44
#define ATMO_FXOS8700AccelerometerMagnetometer_ABILITY_getAccelZ 0x45
#define ATMO_FXOS8700AccelerometerMagnetometer_ABILITY_getMagData 0x46
#define ATMO_FXOS8700AccelerometerMagnetometer_ABILITY_getMagX 0x47
#define ATMO_FXOS8700AccelerometerMagnetometer_ABILITY_getMagY 0x48
#define ATMO_FXOS8700AccelerometerMagnetometer_ABILITY_getMagZ 0x49
#define ATMO_FXOS8700AccelerometerMagnetometer_ABILITY_detectTap 0x4a
#define ATMO_FXOS8700AccelerometerMagnetometer_ABILITY_detectMotion 0x4b
#define ATMO_FXOS8700AccelerometerMagnetometer_ABILITY_detectFreefall 0x4c
#define ATMO_FXOS8700AccelerometerMagnetometer_ABILITY_enableFreefallDetection 0x4d
#define ATMO_FXOS8700AccelerometerMagnetometer_ABILITY_enableMotionDetection 0x4e
#define ATMO_FXOS8700AccelerometerMagnetometer_ABILITY_enableTapDetection 0x4f
#define ATMO_FXOS8700AccelerometerMagnetometer_ABILITY_disableDetection 0x50
#define ATMO_EmbeddedNxpRpkUserButtons_ABILITY_trigger 0x51
#define ATMO_EmbeddedNxpRpkUserButtons_ABILITY_setup 0x52
#define ATMO_EmbeddedNxpRpkUserButtons_ABILITY_topRightPushed 0x53
#define ATMO_EmbeddedNxpRpkUserButtons_ABILITY_bottomRightPushed 0x54
#define ATMO_EmbeddedNxpRpkUserButtons_ABILITY_topLeftPushed 0x55
#define ATMO_EmbeddedNxpRpkUserButtons_ABILITY_bottomLeftPushed 0x56
#define ATMO_ClearTapCount_ABILITY_trigger 0x57
#define ATMO_x_ABILITY_trigger 0x58
#define ATMO_x_ABILITY_setup 0x59
#define ATMO_x_ABILITY_setValue 0x5a
#define ATMO_x_ABILITY_getValue 0x5b
#define ATMO_Increment_ABILITY_trigger 0x5c
#define ATMO_Increment_ABILITY_setup 0x5d
#define ATMO_Increment_ABILITY_performOperation 0x5e
#define ATMO_TapCountChar_ABILITY_trigger 0x5f
#define ATMO_TapCountChar_ABILITY_setup 0x60
#define ATMO_TapCountChar_ABILITY_setValue 0x61
#define ATMO_TapCountChar_ABILITY_written 0x62
#define ATMO_TapCountChar_ABILITY_subscibed 0x63
#define ATMO_TapCountChar_ABILITY_unsubscribed 0x64
#ifdef __cplusplus
}
#endif
#endif
