
#ifndef ATMO_INTERRUPTS_HANDLER_H
#define ATMO_INTERRUPTS_HANDLER_H

#ifdef __cplusplus
	extern "C"{
#endif

#include "../atmo/core.h"
#define ATMO_INTERRUPT(ELEMENT, NAME) ATMO_ ## ELEMENT ## _INTERRUPT_  ## NAME

void ATMO_AmbientLightCharacteristic_INTERRUPT_trigger();
void ATMO_AmbientLightCharacteristic_INTERRUPT_setup();
void ATMO_AmbientLightCharacteristic_INTERRUPT_setValue();
void ATMO_AmbientLightCharacteristic_INTERRUPT_written();
void ATMO_AmbientLightCharacteristic_INTERRUPT_subscibed();
void ATMO_AmbientLightCharacteristic_INTERRUPT_unsubscribed();

void ATMO_SX9500Touch_INTERRUPT_trigger();
void ATMO_SX9500Touch_INTERRUPT_setup();
void ATMO_SX9500Touch_INTERRUPT_getTouchData();
void ATMO_SX9500Touch_INTERRUPT_pressUp();
void ATMO_SX9500Touch_INTERRUPT_pressDown();
void ATMO_SX9500Touch_INTERRUPT_pressLeft();
void ATMO_SX9500Touch_INTERRUPT_pressRight();

void ATMO_EmbeddedPageController_INTERRUPT_trigger();
void ATMO_EmbeddedPageController_INTERRUPT_setup();
void ATMO_EmbeddedPageController_INTERRUPT_displayRootPage();
void ATMO_EmbeddedPageController_INTERRUPT_navigateUp();
void ATMO_EmbeddedPageController_INTERRUPT_navigateDown();
void ATMO_EmbeddedPageController_INTERRUPT_navigateLeft();
void ATMO_EmbeddedPageController_INTERRUPT_navigateRight();
void ATMO_EmbeddedPageController_INTERRUPT_processTopRightButton();
void ATMO_EmbeddedPageController_INTERRUPT_processBottomRightButton();
void ATMO_EmbeddedPageController_INTERRUPT_processTopLeftButton();
void ATMO_EmbeddedPageController_INTERRUPT_processBottomLeftButton();

void ATMO_AmientLight_Pag_INTERRUPT_trigger();
void ATMO_AmientLight_Pag_INTERRUPT_displayPage();
void ATMO_AmientLight_Pag_INTERRUPT_onDisplayed();
void ATMO_AmientLight_Pag_INTERRUPT_topRightButtonPressed();
void ATMO_AmientLight_Pag_INTERRUPT_bottomRightButtonPressed();
void ATMO_AmientLight_Pag_INTERRUPT_topLeftButtonPressed();
void ATMO_AmientLight_Pag_INTERRUPT_bottomLeftButtonPressed();
void ATMO_AmientLight_Pag_INTERRUPT_setup();
void ATMO_AmientLight_Pag_INTERRUPT_onLeave();
void ATMO_AmientLight_Pag_INTERRUPT_setLabel();

void ATMO_Interval_INTERRUPT_trigger();
void ATMO_Interval_INTERRUPT_setup();
void ATMO_Interval_INTERRUPT_interval();

void ATMO_TSL2572AmbientLight_INTERRUPT_trigger();
void ATMO_TSL2572AmbientLight_INTERRUPT_setup();
void ATMO_TSL2572AmbientLight_INTERRUPT_setEnabled();
void ATMO_TSL2572AmbientLight_INTERRUPT_setDisabled();
void ATMO_TSL2572AmbientLight_INTERRUPT_setEnabledDisabled();
void ATMO_TSL2572AmbientLight_INTERRUPT_readAmbientLight();

void ATMO_GetLightStr_INTERRUPT_trigger();

void ATMO_EmbeddedNxpRpkBacklight_INTERRUPT_trigger();
void ATMO_EmbeddedNxpRpkBacklight_INTERRUPT_setup();
void ATMO_EmbeddedNxpRpkBacklight_INTERRUPT_setBacklightOff();
void ATMO_EmbeddedNxpRpkBacklight_INTERRUPT_setBacklightLow();
void ATMO_EmbeddedNxpRpkBacklight_INTERRUPT_setBacklightMedium();
void ATMO_EmbeddedNxpRpkBacklight_INTERRUPT_setBacklightHigh();

void ATMO_TapCountPage_INTERRUPT_trigger();
void ATMO_TapCountPage_INTERRUPT_displayPage();
void ATMO_TapCountPage_INTERRUPT_onDisplayed();
void ATMO_TapCountPage_INTERRUPT_topRightButtonPressed();
void ATMO_TapCountPage_INTERRUPT_bottomRightButtonPressed();
void ATMO_TapCountPage_INTERRUPT_topLeftButtonPressed();
void ATMO_TapCountPage_INTERRUPT_bottomLeftButtonPressed();
void ATMO_TapCountPage_INTERRUPT_setup();
void ATMO_TapCountPage_INTERRUPT_onLeave();
void ATMO_TapCountPage_INTERRUPT_setLabel();

void ATMO_FXOS8700AccelerometerMagnetometer_INTERRUPT_trigger();
void ATMO_FXOS8700AccelerometerMagnetometer_INTERRUPT_setup();
void ATMO_FXOS8700AccelerometerMagnetometer_INTERRUPT_setEnabled();
void ATMO_FXOS8700AccelerometerMagnetometer_INTERRUPT_setDisabled();
void ATMO_FXOS8700AccelerometerMagnetometer_INTERRUPT_setEnabledDisabled();
void ATMO_FXOS8700AccelerometerMagnetometer_INTERRUPT_getAccelData();
void ATMO_FXOS8700AccelerometerMagnetometer_INTERRUPT_getAccelX();
void ATMO_FXOS8700AccelerometerMagnetometer_INTERRUPT_getAccelY();
void ATMO_FXOS8700AccelerometerMagnetometer_INTERRUPT_getAccelZ();
void ATMO_FXOS8700AccelerometerMagnetometer_INTERRUPT_getMagData();
void ATMO_FXOS8700AccelerometerMagnetometer_INTERRUPT_getMagX();
void ATMO_FXOS8700AccelerometerMagnetometer_INTERRUPT_getMagY();
void ATMO_FXOS8700AccelerometerMagnetometer_INTERRUPT_getMagZ();
void ATMO_FXOS8700AccelerometerMagnetometer_INTERRUPT_detectTap();
void ATMO_FXOS8700AccelerometerMagnetometer_INTERRUPT_detectMotion();
void ATMO_FXOS8700AccelerometerMagnetometer_INTERRUPT_detectFreefall();
void ATMO_FXOS8700AccelerometerMagnetometer_INTERRUPT_enableFreefallDetection();
void ATMO_FXOS8700AccelerometerMagnetometer_INTERRUPT_enableMotionDetection();
void ATMO_FXOS8700AccelerometerMagnetometer_INTERRUPT_enableTapDetection();
void ATMO_FXOS8700AccelerometerMagnetometer_INTERRUPT_disableDetection();

void ATMO_EmbeddedNxpRpkUserButtons_INTERRUPT_trigger();
void ATMO_EmbeddedNxpRpkUserButtons_INTERRUPT_setup();
void ATMO_EmbeddedNxpRpkUserButtons_INTERRUPT_topRightPushed();
void ATMO_EmbeddedNxpRpkUserButtons_INTERRUPT_bottomRightPushed();
void ATMO_EmbeddedNxpRpkUserButtons_INTERRUPT_topLeftPushed();
void ATMO_EmbeddedNxpRpkUserButtons_INTERRUPT_bottomLeftPushed();

void ATMO_ClearTapCount_INTERRUPT_trigger();

void ATMO_x_INTERRUPT_trigger();
void ATMO_x_INTERRUPT_setup();
void ATMO_x_INTERRUPT_setValue();
void ATMO_x_INTERRUPT_getValue();

void ATMO_Increment_INTERRUPT_trigger();
void ATMO_Increment_INTERRUPT_setup();
void ATMO_Increment_INTERRUPT_performOperation();

void ATMO_TapCountChar_INTERRUPT_trigger();
void ATMO_TapCountChar_INTERRUPT_setup();
void ATMO_TapCountChar_INTERRUPT_setValue();
void ATMO_TapCountChar_INTERRUPT_written();
void ATMO_TapCountChar_INTERRUPT_subscibed();
void ATMO_TapCountChar_INTERRUPT_unsubscribed();


#ifdef __cplusplus
}
#endif

#endif
