#include "atmosphere_triggerHandler.h"
#include "atmosphere_abilityHandler.h"

#ifdef __cplusplus
	extern "C"{
#endif

void ATMO_TriggerHandler(unsigned int triggerHandleId, ATMO_Value_t *value) {
	switch(triggerHandleId) {
		case ATMO_TRIGGER(AmbientLightCharacteristic, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(AmbientLightCharacteristic, written):
		{
			break;
		}

		case ATMO_TRIGGER(AmbientLightCharacteristic, subscibed):
		{
			break;
		}

		case ATMO_TRIGGER(AmbientLightCharacteristic, unsubscribed):
		{
			break;
		}

		case ATMO_TRIGGER(SX9500Touch, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(SX9500Touch, touchDataRead):
		{
			break;
		}

		case ATMO_TRIGGER(SX9500Touch, upPressed):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(EmbeddedPageController, navigateUp), value);
			break;
		}

		case ATMO_TRIGGER(SX9500Touch, downPressed):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(EmbeddedPageController, navigateDown), value);
			break;
		}

		case ATMO_TRIGGER(SX9500Touch, leftPressed):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(EmbeddedPageController, navigateLeft), value);
			break;
		}

		case ATMO_TRIGGER(SX9500Touch, rightPressed):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(EmbeddedPageController, navigateRight), value);
			break;
		}

		case ATMO_TRIGGER(EmbeddedPageController, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedPageController, navigateUp):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedPageController, navigateDown):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedPageController, navigateLeft):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedPageController, navigateRight):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedPageController, processTopRightButton):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedPageController, processBottomRightButton):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedPageController, processTopLeftButton):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedPageController, processBottomLeftButton):
		{
			break;
		}

		case ATMO_TRIGGER(AmientLight_Pag, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(AmientLight_Pag, onDisplayed):
		{
			break;
		}

		case ATMO_TRIGGER(AmientLight_Pag, topRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(AmientLight_Pag, bottomRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(AmientLight_Pag, topLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(AmientLight_Pag, bottomLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(AmientLight_Pag, onLeave):
		{
			break;
		}

		case ATMO_TRIGGER(Interval, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(Interval, interval):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(TSL2572AmbientLight, readAmbientLight), value);
			ATMO_AbilityHandler(ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, getAccelX), value);
			ATMO_AbilityHandler(ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, getAccelY), value);
			ATMO_AbilityHandler(ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, getAccelZ), value);
			ATMO_AbilityHandler(ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, getMagX), value);
			ATMO_AbilityHandler(ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, getMagY), value);
			ATMO_AbilityHandler(ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, getMagZ), value);
			break;
		}

		case ATMO_TRIGGER(TSL2572AmbientLight, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(TSL2572AmbientLight, ambientLightRead):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(AmbientLightCharacteristic, setValue), value);
			ATMO_AbilityHandler(ATMO_ABILITY(GetLightStr, trigger), value);
			break;
		}

		case ATMO_TRIGGER(GetLightStr, triggered):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(AmientLight_Pag, setLabel), value);
			break;
		}

		case ATMO_TRIGGER(EmbeddedNxpRpkBacklight, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedNxpRpkBacklight, backlightSet):
		{
			break;
		}

		case ATMO_TRIGGER(TapCountPage, triggered):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(ClearTapCount, trigger), value);
			break;
		}

		case ATMO_TRIGGER(TapCountPage, onDisplayed):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, enableTapDetection), value);
			break;
		}

		case ATMO_TRIGGER(TapCountPage, topRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(TapCountPage, bottomRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(TapCountPage, topLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(TapCountPage, bottomLeftButtonPressed):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(ClearTapCount, trigger), value);
			break;
		}

		case ATMO_TRIGGER(TapCountPage, onLeave):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(FXOS8700AccelerometerMagnetometer, disableDetection), value);
			break;
		}

		case ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, accelDataRead):
		{
			break;
		}

		case ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, accelXRead):
		{
			break;
		}

		case ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, accelYRead):
		{
			break;
		}

		case ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, accelZRead):
		{
			break;
		}

		case ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, magDataRead):
		{
			break;
		}

		case ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, magXRead):
		{
			break;
		}

		case ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, magYRead):
		{
			break;
		}

		case ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, magZRead):
		{
			break;
		}

		case ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, tapDetected):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(x, trigger), value);
			break;
		}

		case ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, motionDetected):
		{
			break;
		}

		case ATMO_TRIGGER(FXOS8700AccelerometerMagnetometer, freefallDetected):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedNxpRpkUserButtons, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedNxpRpkUserButtons, topRightPushed):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedNxpRpkUserButtons, bottomRightPushed):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedNxpRpkUserButtons, topLeftPushed):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedNxpRpkUserButtons, bottomLeftPushed):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(EmbeddedPageController, processBottomLeftButton), value);
			break;
		}

		case ATMO_TRIGGER(ClearTapCount, triggered):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(x, setValue), value);
			break;
		}

		case ATMO_TRIGGER(x, triggered):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(Increment, performOperation), value);
			break;
		}

		case ATMO_TRIGGER(x, valueSet):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(TapCountPage, setLabel), value);
			ATMO_AbilityHandler(ATMO_ABILITY(TapCountChar, setValue), value);
			break;
		}

		case ATMO_TRIGGER(x, valueRetrieved):
		{
			break;
		}

		case ATMO_TRIGGER(Increment, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(Increment, operationPerformed):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(x, setValue), value);
			break;
		}

		case ATMO_TRIGGER(TapCountChar, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(TapCountChar, written):
		{
			break;
		}

		case ATMO_TRIGGER(TapCountChar, subscibed):
		{
			break;
		}

		case ATMO_TRIGGER(TapCountChar, unsubscribed):
		{
			break;
		}

	}

}

#ifdef __cplusplus
}
#endif
